#ifndef BBOX2D_H
#define BBOX2D_H

/*
* "$Header:$"
*/

#include "Point2D.h"

using namespace std ;

/**
* @brief A 2-dimensional rectangular boundary box parallel to the two Cartesian axes.
* @since 2013-07-04
* @author Richard J. Mathar
*/
class Bbox2D {

public:
	/** The two points at the lower left and upper right corner.
	*/
	Point2D limits[2] ;

	Bbox2D(const Point2D &ptll, const Point2D & ptur) ;
	Bbox2D() ;
	// ~Bbox2D() ;

	Bbox2D apply(const RotTrans2D & rt) const ;

	void include(const Point2D &pt) ;

	bool isInside(const Point2D & pt) const ;

	Point2D lowerRight() const ;
	Point2D upperLeft() const ;

protected:

private:

} ; /* Bbox2D */

#endif /* BBOX2D_H */
