#ifndef PIXIMAGE_H
#define PIXIMAGE_H
/*
* "$Header:$"
*
*/

#include <CCfits/CCfits>

#include "RotTrans2D.h"
#include "Bbox2D.h"
#include "Square2D.h"

using namespace std ;
using namespace CCfits ;

/**
* @brief A rectangular 2-dimensional array of pixels with individual values.
* @since 2013-07-04
* @author Richard J. Mathar
*/
class PixImage {

public:
	/** The values (intensities) within the pixels.
	*/
	//double *vals ;
	valarray<double> vals ;

	/** Number of rows
	*/
	int rows ;

	/** Number of columns
	*/
	int cols ;

	PixImage(const int ncols, const int nrows) ;
	PixImage() ;
	PixImage( FITS & fit, int slic=0) ;
	~PixImage() ;

	operator Bbox2D() const ;
	FITS * toFits(const char *foutname) const ;

#if 0
	PixImage apply(const RotTrans2D & rt) const ;
#else
	PixImage * apply(const RotTrans2D & rt) const ;
#endif

	double at(const int row, const int col) const ;

	int idx(const int row, const int col) const ;

	Square2D hull(const RotTrans2D & rt, const int row, const int col, int idxReg[2][2], const Bbox2D & bbrot) const ;



protected:

private:

} ; /* PixImage */

#endif /* PIXIMAGE_H*/

