#ifndef POINT2D_H
#define POINT2D_H
/*
* "$Header:$"
*
*/

/* forward declaration needed because we have circular apply functions.
#include "RotTrans2D.h"
*/
class RotTrans2D ;

using namespace std ;

/**
* A point with 2 coordinates represented in a Cartesian coordinate system.
* @since 2013-07-03
* @author Richard J. Mathar
*/
class Point2D {

public:
	/** The two Cartesian coordinates x and y of the point.
	*/
	double coord[2] ;

	Point2D(double x, double y) ;
	Point2D(const double xandy[2]) ;
	Point2D() ;
	// ~Point2D() ;

	Point2D to(const Point2D & oth) const ;
	Point2D plus(const Point2D & oth) const ;
	Point2D turn90() const ;
	Point2D apply(const RotTrans2D & rt) const ;

	double dist(const Point2D & oth) const ;

	double len() const ;

	double dotprod(const Point2D &oth) const ;

#if 0
	Point2D & operator= (const Point2D & rhs) ;
#endif
	Point2D & operator-= (const Point2D & rhs) ;
	Point2D & operator+= (const Point2D & rhs) ;
protected:

private:

} ; /* Point2D */

Point2D operator+ (const Point2D & left, const Point2D & right) ;


#endif /* POINT2D_H */

