#ifndef SQUARE2D_H
#define SQUARE2D_H
/*
* "$Header:$"
*
*/

// class Tria2D ;

#include "Point2D.h"
#include "Line2D.h"
#include "Circle2D.h"
#include "Tria2D.h"
#include "Bbox2D.h"

using namespace std ;

/**
* @brief A square represented by the four vertices of the corners.
* @since 2013-07-03
* @author Richard J. Mathar
*/
class Square2D {

public:
	/** The points at the vertices.
	*/
	Point2D vert[4] ;

	/** Edge length
	*/
	double eLen ;

	Square2D(const Point2D &pt1, const Point2D & pt2) ;
	Square2D(const Point2D &pt1, const Point2D & pt2,
		const Point2D & pt3, const Point2D & pt4) ;
	Square2D() ;
	// ~Square2D() ;

	operator Bbox2D() const ;

	Line2D edge(int no) const ;

	Circle2D circumC() const ;

	double area() const ;

	Tria2D * dissect()  const ;

	Square2D apply(const RotTrans2D & rt) const ;

	vector<Tria2D> intersect(const Square2D & oth) const ;

protected:

private:

} ; /* Square2D */

#endif /* SQUARE2D_H */

